Bug 42611 - wrong compiler error when using IEnumerable.Sum
Summary: wrong compiler error when using IEnumerable.Sum
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: 4.4.0 (C7)
Hardware: PC Linux
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2016-07-16 11:59 UTC by ahmad13932013
Modified: 2016-07-29 13:31 UTC (History)
1 user (show)

See Also:
Tags:
Is this bug a regression?: ---
Last known good build:


Attachments
the program causing faulty compiler error (360 bytes, text/x-csharp)
2016-07-16 11:59 UTC, ahmad13932013
Details

Description ahmad13932013 2016-07-16 11:59:43 UTC
Created attachment 16696 [details]
the program causing faulty compiler error

I have this code 
    int? sum = Enumerable.Range(0, 1000).Sum<int>((int i) =>
              {
                  if (((i % 3) == 0) && ((i % 5) == 0))
                      return i;
                  return null;
            });
The expected output : to compile fine(with warnings perhaps)

The actual output : compiler error : error CS0266: Cannot implicitly convert type `decimal?' to `int?'. An explicit conversion exists (are you missing a cast?) (CS0266) (test)

My distro is Arch linux and I have mono 4.4.1 specifically .
Comment 1 Marek Safar 2016-07-29 13:31:47 UTC
Fixed in master and Mono 4.6

Notice (2018-05-21): bugzilla.xamarin.com will be switching to read-only mode on Thursday, 2018-05-25 22:00 UTC.

Please join us on Visual Studio Developer Community and GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs and copy them to the new locations as needed for follow-up. The See Also field on each Bugzilla bug will be updated with a link to its new location when applicable.

After Bugzilla is read-only, if you have new information to add for a bug that does not yet have a matching issue on Developer Community or GitHub, you can create a follow-up issue in the new location. Copy and paste the title and description from this bug, and then add your new details. You can get a pre-formatted version of the title and description here:

In special cases you might also want the comments:

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Note You need to log in before you can comment on or make changes to this bug.